#define APPNAME  "test - colorrect"
#define APPTITLE "test - colorrect"

#define _RELEASE_(p) { if(p) { (p)->Release(); (p)=NULL; };}
#define _DELETE_(p)  { if(p) { delete (p);     (p)=NULL; };}

#include <windows.h>
#include <time.h>

#include <d3d9.h>
#include <d3dx9.h>
#pragma comment (lib, "dxguid.lib")
#pragma comment (lib, "d3d9.lib")
#pragma comment (lib, "d3dx9.lib")


//ؽ ü Ÿ 
struct CUSTOMVERTEX { 
	FLOAT x, y, z; 
	DWORD   color;
};
#define D3DFVF_CUSTOMVERTEX ( D3DFVF_XYZ | D3DFVF_DIFFUSE)

bool g_bIsFullScreen = false;	    // is our app Full screen or not
int g_iScreenX = 640, g_iScreenY = 480;	// use this if 'not'
D3DDISPLAYMODE  g_d3ddm;


BOOL	g_bActive = TRUE;
HWND	g_hWnd = NULL;

LPDIRECT3D9             g_d3d        = NULL; // our main d3d8 interface
LPDIRECT3DDEVICE9       g_d3d_Device = NULL; // our d3d8 device
LPDIRECT3DVERTEXBUFFER9 g_VertexBuffer = NULL; // our VertexBuffer
D3DPRESENT_PARAMETERS	g_d3dpp; 

LPDIRECT3DVERTEXSHADER9	      g_hVShader = 0;  //ؽ ̴ ڵ
LPDIRECT3DVERTEXDECLARATION9  g_pVertexDeclaration = 0;  //ؽ ̴ 
LPD3DXCONSTANTTABLE           g_pVertexConstantTable = NULL;  //ؽ ̺  ڵ

D3DXMATRIX   g_matProj;
D3DXMATRIX	 g_matCameraView;

HRESULT CreateShader();
LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);


bool WindowInit(HINSTANCE hInst, int nCmdShow);
bool AppInit(HINSTANCE hInst, int nCmdShow);
HRESULT InitD3D(HWND hWnd);
void SetupCamera(HWND hWnd);
bool RenderInit();
void DestroyDirect3D8();
HRESULT ResetDeviceObjects();
HRESULT RenderLoop();
HRESULT Render3D();
void	DestroyDirect3D8();

float g_fx = 0.0f;
float g_fy = 0.0f;
float g_fDegree = 0.0f;
float g_fTurretDegree = 0.0f;



void MovPosition(float fMove)
{
#if  1		//y  ȸ 0 Ҷ
	double sin_a = -sin( D3DXToRadian(g_fDegree) );
	double cos_a = cos( D3DXToRadian(g_fDegree) );

	g_fx = float(fMove * sin_a + g_fx);
	g_fy = float(fMove * cos_a + g_fy);
#else
	double sin_a = sin( D3DXToRadian(g_fDegree) );
	double cos_a = cos( D3DXToRadian(g_fDegree) );

	g_fy = float(fMove * sin_a + g_fy);
	g_fx = float(fMove * cos_a + g_fx);
#endif
}
//-----------------------------------------------------------------------------
LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_ACTIVATE:
		g_bActive = LOWORD(wParam);
		return 0;
		break;

	case WM_KEYDOWN:
		if (wParam == VK_ESCAPE)
		{
			DestroyDirect3D8();
			DestroyWindow(hWnd);
			PostQuitMessage(0);
		}
		
		{
			//if ((lParam & 0x40000000)) // ư   ִٸ......
			//		break;

			switch(wParam)
			{
			//ü
			case VK_UP:
				MovPosition(0.1f);
				break;
			case VK_DOWN:
				MovPosition(-0.1f);
				break;
			case 'A':
			case VK_LEFT:
				g_fDegree += 5.0f;
				break;
			case 'D':
			case VK_RIGHT:
				g_fDegree -= 5.0f;
				break;
			//ž
			case '1':
				g_fTurretDegree += 5.0;
				break;
			case '2':
				g_fTurretDegree -= 5.0;
				break;
			}
		}
		break;

	case WM_CLOSE:          
		DestroyDirect3D8();
        DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	case WM_SYSCOMMAND:
		// Prevent moving/sizing and power loss in fullscreen mode
		switch( wParam )
		{
			case SC_MOVE:
			case SC_SIZE:
			case SC_MAXIMIZE:
			case SC_KEYMENU:
			case SC_MONITORPOWER:
				if( g_bIsFullScreen)
					return 1;
				break;
		}
		break;

    case WM_NCHITTEST:
       // Prevent the user from selecting the menu in fullscreen mode
        if(g_bIsFullScreen)
              return HTCLIENT;
        break;
/*  콺 Ŀ ʿ   Ѵ
	case WM_SETCURSOR:
		SetCursor (NULL);
		return 0;
		break; 
*/
	};
	return DefWindowProc(hWnd, message, wParam, lParam);
}
//-----------------------------------------------------------------------------
bool WindowInit(HINSTANCE hInst, int nCmdShow)
{
	WNDCLASS		    wcl;
		
	wcl.hInstance		= hInst;
	wcl.lpszClassName	= APPNAME;
	wcl.lpfnWndProc		= WindowProc;
	wcl.style			= 0;

	wcl.hIcon			= LoadIcon (NULL, IDC_ICON);
	wcl.hCursor			= LoadCursor (NULL, IDC_ARROW);
	wcl.lpszMenuName	= NULL;

	wcl.cbClsExtra		= 0;
	wcl.cbWndExtra		= 0;
	wcl.hbrBackground	= (HBRUSH) GetStockObject (BLACK_BRUSH);

	RegisterClass (&wcl);

	if(g_bIsFullScreen)
	{
		g_hWnd = CreateWindowEx (
			NULL,
			APPNAME,
			APPTITLE,
			WS_POPUP|WS_SYSMENU|WS_VISIBLE, 
			0, 0, 
			g_d3ddm.Width,
			g_d3ddm.Height,
			NULL,
			NULL,
			hInst,
			NULL);
	}
	else
	{
		int sx = GetSystemMetrics (SM_CXSCREEN);
		int sy = GetSystemMetrics (SM_CYSCREEN);

		g_hWnd = CreateWindowEx (
			NULL,
			APPNAME,
			APPTITLE,
			WS_OVERLAPPED | WS_SYSMENU,
			sx/2 - g_iScreenX/2, sy/2 - g_iScreenY/2,
			g_iScreenX,
			g_iScreenY,
			NULL,
			NULL,
			hInst,
			NULL);
	};

	if(!g_hWnd) 
		return false;

	return true;
}
//-----------------------------------------------------------------------------
bool AppInit(HINSTANCE hInst, int nCmdShow)
{
	srand (time(0)); // randomize timer

	if(!WindowInit (hInst, nCmdShow)) 
		return false;

	ShowWindow (g_hWnd, nCmdShow);
	UpdateWindow (g_hWnd);
    
	return true;
}
//-----------------------------------------------------------------------------
HRESULT InitD3D(HWND hWnd)
{
	ZeroMemory (&g_d3dpp, sizeof(g_d3dpp));

    if( NULL == ( g_d3d = Direct3DCreate9( D3D_SDK_VERSION ) ) )
        return E_FAIL;

	if(g_bIsFullScreen)
	{
		g_d3dpp.BackBufferWidth = g_d3ddm.Width;
		g_d3dpp.BackBufferHeight = g_d3ddm.Height;
		g_d3dpp.BackBufferCount = 1;
		g_d3dpp.FullScreen_RefreshRateInHz = g_d3ddm.RefreshRate; //D3DPRESENT_RATE_DEFAULT
		g_d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_ONE;
	}
	else
	{
		if( FAILED( g_d3d->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &g_d3ddm)))
			return E_FAIL;
	}

    g_d3dpp.Windowed = !g_bIsFullScreen;
    g_d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
    g_d3dpp.BackBufferFormat = g_d3ddm.Format;

	g_d3dpp.EnableAutoDepthStencil	= TRUE; 
	g_d3dpp.AutoDepthStencilFormat	= D3DFMT_D16;

    if(FAILED(g_d3d->CreateDevice (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, 
								   D3DCREATE_SOFTWARE_VERTEXPROCESSING, 
								   &g_d3dpp, &g_d3d_Device)))
	{
		g_d3dpp.AutoDepthStencilFormat	= D3DFMT_D32;
		if(FAILED(g_d3d->CreateDevice (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, 
								   D3DCREATE_SOFTWARE_VERTEXPROCESSING, 
								   &g_d3dpp, &g_d3d_Device)))
			return E_FAIL;
	}

	g_d3d_Device->SetRenderState( D3DRS_ZENABLE, TRUE );
	g_d3d_Device->SetRenderState( D3DRS_AMBIENT, 0xffffffff );
	g_d3d_Device->SetRenderState( D3DRS_LIGHTING, FALSE );
	return S_OK;
}
//-----------------------------------------------------------------------------
void SetupCamera(HWND hWnd)
{
	D3DXVECTOR3  cameraTarget;
    D3DXVECTOR3  cameraPos;

	// Set where camera is viewing from
	cameraPos.x = 0.0f;
	cameraPos.y = 0.0f;
	cameraPos.z = -10.0f;
	// Set what camera is looking at
	cameraTarget.x = 0.0f;
	cameraTarget.y = 0.0f;
	cameraTarget.z = 0.0f;

	// Setup Camera View
	D3DXMatrixLookAtLH( &g_matCameraView, 
						&cameraPos, 
						&cameraTarget, 
						&D3DXVECTOR3( 0.0f, 1.0f, 0.0f ) );
	// Tell the device to use the camera view for the viewport
	g_d3d_Device->SetTransform( D3DTS_VIEW, &g_matCameraView );

	// Setup Projection 
	RECT rect;
	GetClientRect(hWnd, &rect);
	float width = (float)rect.right, height = (float)rect.bottom;
	D3DXMatrixPerspectiveFovLH( &g_matProj, D3DX_PI/4, width/height, 1.0f, 100.0f );
	// Tell the device to use the above matrix for projection
	g_d3d_Device->SetTransform( D3DTS_PROJECTION, &g_matProj );
}
//-----------------------------------------------------------------------------
bool RenderInit()
{
	void	*lpVertices;

    CUSTOMVERTEX vertex[] =
    {
		// triangle
        {-0.6f,-0.6f, 0.45f, 0x66cccc},
        { 0.0f, 0.6f, 0.45f, 0x66cccc},
		{ 0.6f,-0.6f, 0.45f, 0x66cccc},
		// square
		{-0.6f,-1.5f, 0.5f, 0xff},
		{-0.6f, 1.5f, 0.5f, 0xff0077},
		{ 0.6f,-1.5f, 0.5f, 0xff},
		{ 0.6f, 1.5f, 0.5f, 0xff0077}
    };
	
	// Create the vertex buffer
	if(FAILED(g_d3d_Device->CreateVertexBuffer(7*sizeof(CUSTOMVERTEX), 
		                   0, D3DFVF_CUSTOMVERTEX, D3DPOOL_DEFAULT, &g_VertexBuffer, NULL))) 
	{
		return false;
	}
	// Lock the buffer
	if(FAILED(g_VertexBuffer->Lock(0, sizeof(vertex), &lpVertices, 0))) 
	{
		return false;
	}
	
	// Copy the g_Vertices information into the buffer
	memcpy(lpVertices, vertex, sizeof(vertex));
	// Unlock the buffer
	g_VertexBuffer->Unlock();
	return true;
}
//-----------------------------------------------------------------------------
void DestroyDirect3D8()
{
    _RELEASE_(g_hVShader);
	_RELEASE_(g_pVertexDeclaration);
	_RELEASE_(g_pVertexConstantTable);

	_RELEASE_ (g_VertexBuffer);
	_RELEASE_ (g_d3d_Device);
	_RELEASE_ (g_d3d);
}
//-----------------------------------------------------------------------------
HRESULT ResetDeviceObjects()
{
	HRESULT hr;

    // Release all vidmem objects
    //if( FAILED( hr = InvalidateDeviceObjects() ) )
    //    return hr;

	// Reset the device
	if( FAILED( hr = g_d3d_Device->Reset( &g_d3dpp ) ) )
		return hr;

	return S_OK;
}
//-----------------------------------------------------------------------------
HRESULT RenderLoop()
{
    HRESULT hr;

    // Test the cooperative level to see if it's okay to render
    if( FAILED( hr = g_d3d_Device->TestCooperativeLevel() ) )
    {
        // If the device was lost, do not render until we get it back
        if( D3DERR_DEVICELOST == hr )
            return S_OK;

        // Check if the device needs to be resized.
        if( D3DERR_DEVICENOTRESET == hr )
        {
            // If we are windowed, read the desktop mode and use the same format for
            // the back buffer
            if( !g_bIsFullScreen )
            {
				g_d3d->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &g_d3ddm);
                g_d3dpp.BackBufferFormat = g_d3ddm.Format;
            }

            if( FAILED( hr = ResetDeviceObjects() ) )
                return hr;
        }
        return hr;
    }

    // Render the scene as normal
    if( FAILED( hr = Render3D() ) )
        return hr;

	return S_OK;
}
//-----------------------------------------------------------------------------
void MoveShip(float fx, float fy)
{
	D3DXMATRIX	mScale1, mRot1, mTran1, mResult1;
	D3DXMATRIX	mScale2, mRot2, mTran2, mResult2;
	D3DXMATRIX	mScale3, mRot3, mTran3, mResult3;

	//ü
	//SRT
	D3DXMatrixScaling( &mScale1, 1.1f, 1.1f, 1.1f );
	D3DXMatrixRotationZ(&mRot1, D3DXToRadian(g_fDegree));
	D3DXMatrixTranslation( &mTran1, fx, fy, 0.0f);

	mResult1 = mScale1 * mRot1 * mTran1;
	if(g_pVertexConstantTable)
	{
		D3DXMATRIX ShaderMatrix = mResult1 * g_matCameraView * g_matProj;

		//Get the transpose
		g_pVertexConstantTable->SetMatrix(g_d3d_Device, "worldViewProj", &ShaderMatrix);

		//Pass the transposed matrix to the shader
		g_d3d_Device->SetVertexDeclaration( g_pVertexDeclaration);
		g_d3d_Device->SetVertexShader( g_hVShader);
		g_d3d_Device->DrawPrimitive( D3DPT_TRIANGLESTRIP, 3, 2 );

		//  
		g_d3d_Device->SetVertexShader(NULL);
		g_d3d_Device->SetFVF(D3DFVF_CUSTOMVERTEX);
	}
	else
	{
		g_d3d_Device->SetTransform( D3DTS_WORLD, &mResult1);
		g_d3d_Device->DrawPrimitive( D3DPT_TRIANGLESTRIP, 3, 2 );
	}


	//ž
	D3DXMatrixScaling( &mScale2, 1.0f, 1.0f, 1.0f );
	D3DXMatrixRotationZ(&mRot2, D3DXToRadian(g_fTurretDegree));
	D3DXMatrixTranslation( &mTran2, 0.0f, -0.7f, 0.0f );
	
    mResult2 = mScale2 * mRot2 * mTran2 * mResult1;
	g_d3d_Device->SetTransform( D3DTS_WORLD, &mResult2 );
	g_d3d_Device->DrawPrimitive( D3DPT_TRIANGLELIST, 0, 1 );

	//
	D3DXMatrixScaling( &mScale3, 0.1f, 0.3f, 1.0f );
	D3DXMatrixRotationZ(&mRot3, 0.0f);
	D3DXMatrixTranslation( &mTran3, 0.0f, -0.1f, -0.5f);

	mResult3 = mScale3 * mRot3 * mTran3 * mResult2;
	g_d3d_Device->SetTransform( D3DTS_WORLD, &mResult3 );
	g_d3d_Device->DrawPrimitive( D3DPT_TRIANGLESTRIP, 3, 2 );
}
//-----------------------------------------------------------------------------
HRESULT Render3D ()
{
	HRESULT hr;

	// Clear the scene
	g_d3d_Device->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,
		                                D3DCOLOR_XRGB(150,150,255), 1.0f, 0 );
	g_d3d_Device->BeginScene();

	g_d3d_Device->SetStreamSource( 0,  g_VertexBuffer, 0, sizeof(CUSTOMVERTEX) );
	g_d3d_Device->SetFVF( D3DFVF_CUSTOMVERTEX );

	MoveShip(g_fx, g_fy);

	g_d3d_Device->EndScene();
	// Output the scene
	hr = g_d3d_Device->Present( NULL, NULL, NULL, NULL );
	return hr;
}
//-----------------------------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;
	if(!AppInit(hInst, nCmdShow)) 
		return -1;
	if(InitD3D(g_hWnd)!= S_OK )
		return -1;
	
	SetupCamera(g_hWnd);

	if(FAILED(CreateShader()))
		return -1;
	if(!RenderInit())
		return -1;

	BOOL bGotMsg;

	msg.message = WM_NULL;
	PeekMessage( &msg, NULL, 0U, 0U, PM_NOREMOVE );
    while( WM_QUIT != msg.message  )
    {
        // Use PeekMessage() if the app is active, so we can use idle time to
        // render the scene. Else, use GetMessage() to avoid eating CPU time.
        if( g_bActive )
            bGotMsg = PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE );
        else
            bGotMsg = GetMessage( &msg, NULL, 0U, 0U );

        if( bGotMsg )
        {
            // Translate and dispatch the message
            //if( 0 == TranslateAccelerator( g_hWnd, hAccel, &msg ) )
            {
                TranslateMessage( &msg );
                DispatchMessage( &msg );
            }
        }
        else
        {
            // Render a frame during idle time (no messages are waiting)
            if( g_bActive )//&& m_bReady )
            {
                if( FAILED( RenderLoop()))
                    SendMessage( g_hWnd, WM_CLOSE, 0, 0 );
            }
        }
    }

	UnregisterClass( APPNAME, hInst);
	return 0;
}
//-----------------------------------------------------------------------------
HRESULT CreateShader()
{
	const char szHlslShader[] =
"   float4x4 worldViewProj : WORLDVIEWPROJ;                                         \n"
"                                                                                   \n"
"   struct VS_OUTPUT                                                                \n"
"   {                                                                               \n"
"        float4 pos  : POSITION;                                                    \n"
"        float4 diff : COLOR0;                                                      \n"
"   };                                                                              \n"
"                                                                                   \n"
"   VS_OUTPUT VertexShader_main( float3 pos  : POSITION,  float4 diff : COLOR0)     \n"
"   {                                                                               \n"
"        VS_OUTPUT Out = (VS_OUTPUT)0;                                              \n"
"                                                                                   \n"
"        Out.pos = mul(float4(pos, 1), worldViewProj);                              \n"
"        Out.diff = diff;                                                           \n" 
"                                                                                   \n"
"        return Out;                                                                \n"
"   }                                                                               \n"
"";

	D3DVERTEXELEMENT9 Declaration[] =
	{
		{0, 0,  D3DDECLTYPE_FLOAT3,   D3DDECLMETHOD_DEFAULT,   D3DDECLUSAGE_POSITION, 0},
		{0, 12, D3DDECLTYPE_D3DCOLOR, D3DDECLMETHOD_DEFAULT,   D3DDECLUSAGE_COLOR,    0},
		D3DDECL_END()
	};

    if( FAILED(g_d3d_Device->CreateVertexDeclaration( Declaration, &g_pVertexDeclaration )))
    {
		_RELEASE_(g_pVertexDeclaration);
		return E_FAIL;
    }

	ID3DXBuffer* pShaderBuffer;
	ID3DXBuffer* pShaderErrors;

	if (FAILED(D3DXCompileShader(szHlslShader, sizeof(szHlslShader), 0, NULL, 
									"VertexShader_main", "vs_1_1", D3DXSHADER_DEBUG, 
									&pShaderBuffer, &pShaderErrors, &g_pVertexConstantTable)))
	{
		char* str = (char*)pShaderErrors->GetBufferPointer();
		return E_FAIL;
	}

	if (FAILED(g_d3d_Device->CreateVertexShader((DWORD *)pShaderBuffer->GetBufferPointer(), &g_hVShader)))
		return E_FAIL;
	_RELEASE_(pShaderBuffer);
	return S_OK;
}